



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>笔记：Spring Boot 配置详解</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">笔记：Spring Boot 配置详解</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-07 17:41:17 </span>
						</div>
										<div class="post-content">
											
		<p>Spring Boot 针对常用的开发场景提供了一系列自动化配置来减少原本复杂而又几乎很少改动的模板配置内容，但是，我们还是需要了解如何在Spring Boot中修改这些自动化的配置，以应对一些特殊场景</p>
<p><strong>配置文件</strong></p>
<p>Spring Boot的默认配置文件位置为 src/main/resources/application.properties ，关于 Spring Boot 应用的配置文件内容都可以在该文件中，根据我们引入的不同模块，可以在这里定义容器端口号、数据库连接信息、日志级别等各种配置信息，常用配置如下：</p>
<ul><li>server.context-path：指定上下文路径，比如默认访问路径是http://localhost:8080，我将之改为http://localhost:8081/hello，就需要配置此属性值为 /hello</li>
<li>server.port=8090 ：指定服务端口号为 8090</li>
<li>spring.application.name=hello：指定应用名（该名字后续Spring Cloud 中会被注册为服务名）</li></ul>
<p><strong>自定义参数</strong></p>
<p>除了可以在Spring Boot的配置文件中设置各个模块中预定义的配置属性，也可以在配置文件中定义一些我们需要的自定义属性，比如在配置文件中增加如下内容：</p>
<p>book.name = springCloud</p>
<p>book.author=李四</p>
<p>然后，可以在应用中，通过@Value注解来加载这些自定义的参数，比如：</p>
<p>@Component</p>
<p>public class Book {</p>
<p>        @Value ("${book.name}")</p>
<p>        private String name;</p>
<p>        @Value ("${book.author}")</p>
<p>        private String author;</p>
<p>}</p>
<p>@Value注解可以支持两种表达式来进行配置，如下所示：</p>
<ul><li>一种是上面代码所示的 PlaceHolder 方式，格式为${…} 大括号内为PlaceHolder</li>
<li>另一种是 SpEL表达式（Spring Expression Language），格式为 #{…}，大括号内为 SpEL 表达式</li></ul>
<p>通过自定义注入实体，就可以读取到配置属性，示例代码如下：</p>
<p>@RestController</p>
<p>@RequestMapping ("/hello")</p>
<p>public class HelloController {</p>
<p> <br />
 </p>
<p>        @Autowired</p>
<p>        private Book book;</p>
<p> <br />
 </p>
<p>        @RequestMapping ("getCount")</p>
<p>        public String getCount() {</p>
<p>                return<br />
					"ok " + book.getName();</p>
<p>        }</p>
<p>}</p>
<p><strong>参数引用</strong></p>
<p>在 application.properties中的个参数之间可以直接通过使用 PlaceHolder 的方式来进行引用，比如：</p>
<p>book.name=springCloud</p>
<p>book.author=李四</p>
<p>book.desc= 作者 ${book.author} 写的 ${book.name}</p>
<p><strong>使用随机数</strong></p>
<p>在一些特殊的情况下，我们希望有些参数每次被加载时候不是一个固定的值，比如密钥、服务端口等，在Spring Boot 的属性配置文件中，可以使用${random}配置来产生随机的int值、long值或者string字符串，这样我们就可以很容易的通过配置随机生成属性，比如：</p>
<p>#-随机生成<strong>8080</strong>-<strong>8090</strong>内的随机数</p>
<p>server.port=${random.int(<strong>8080</strong>,<strong>8090</strong>)}</p>
<p>#--------------------------</p>
<p>#-随机生成字符串</p>
<p>org.drsoft.random=${random.value}</p>
<p>#-随机生成int</p>
<p>org.drsoft.random.int=${random.int}</p>
<p>#-随机生成long</p>
<p>org.drsoft.random.long=${random.long}</p>
<p>#-随机生成<strong>10</strong>以内的int</p>
<p>org.drsoft.random.intRagne=${random.int(<strong>10</strong>)}</p>
<p>#-机生成 uuid</p>
<p><strong>命令行参数</strong></p>
<p>使用命令 java -jar 来启动的方式，该命令除了启动应用外，还可以在命令行中指定应用的参数，比如 java - jar xxx.jar --server.port=8090 直接以命令行的方式设置服务端口属性，在用命令行方式启动 Spring Boot应用时，连续的两个减号就是对application.properties 中的属性进行赋值的标识</p>
<p><strong>多环境配置</strong></p>
<p>多环境的配置，各种项目构建工具或是框架的基本思路是一致的，通过配置多份不同环境的配置文件，在通过打包命令指定需要打包的内容之后进行区分打包，在Spring<br />
			Boot<br />
			中，多环境配置的文件名需要满足application-{profile}.properties<br />
			的格式，其中{profile}对应环境标识，如下：</p>
<ul><li>application-dev.properties：开发环境</li>
<li>application-test.properties：测试环境</li>
<li>application-prod.properties：生成环境</li></ul>
<p>至于具体哪个配置文件会被加载，需要在<br />
			application.properties<br />
			文件中通过spring.profiles.action<br />
			属性来设置，其值对应配置文件中的{profile}<br />
			值。</p>
<p>加载顺序</p>
<p>为了能够更合理的重写各属性的值，其Spring<br />
			Boot<br />
			使用了下面这种较为特别的属性加载顺序：</p>
<ul><li>命令行中传入的参数</li>
<li>SPRING_APPLICATION_JSON中的属性，SPRING_APPLICATION_JSON 是以JSON格式配置在系统环境变量中的内容</li>
<li>java：comp/env<br />
				中的<br />
				JNDI<br />
				属性</li>
<li>java<br />
				的系统属性，可以通过System.getProperties（）获取的内容</li>
<li>操作系统的环境变量</li>
<li>通过<br />
				random.* 配置的随机属性</li>
<li>位于当前应用<br />
					Jar<br />
					包之外，针对不同{profile}环境的配置文件内容</li>
<li>位于当前应用<br />
				Jar<br />
				包之内，针对不同{profile}环境的配置文件内容</li>
<li>位于当前应用<br />
					Jar<br />
					包之外的<br />
					application.properties<br />
					配置内容</li>
<li>位于当前应用<br />
				Jar<br />
				包之内的<br />
				application.properties<br />
				配置内容</li>
<li>在<br />
				@Configuration<br />
				注解修改的类，通过<br />
				@PropertySource<br />
				注解定义的属性</li>
<li>应用默认属性，使用<br />
				SpringApplication.setDefaultProperties<br />
				定义的内容</li></ul>
<p>可以看到其中标黄的都是从应用Jar包之外读取配置文件，所以，实现外部化配置的原理就是从此切入，为其指定外部配置文件的加载位置来取代Jar包之内的配置内容。</p>																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9jlomgq.html">Android根据文件路径使用File类获取文件相关信息</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q726ox9.html">java&period;logging的重定向？</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9p4rp49.html">【Visual Lisp】表处理专题</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxpjyd9.html">tomcat 配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zmk2z9.html">&lbrack;转&rsqb;Eclipse Java注释模板设置详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1jppj9.html">Oracle查找表的外键引用关系</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1ykln9.html">Hibernate3&period;3用户手册摘要-1-辅助类&comma;session</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdlk2k8.html">火箭18号秀光膀为父母割草&lpar;FW&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmdmye9.html">RMI、RPC、SOAP通讯技术介绍及比对 - XML&sol;SOAP</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1r1nk9.html">VS2005中SetUnhandledExceptionFilter函数应用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnxx608.html">Hadoop学习记录（5）&vert;集群搭建&vert;节点动态添加删除</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdey2k09.html">使用WebFrom来模拟一些MVC的MODEL与View的数据交互功能</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmw1kz9.html">oldboy第四天学习</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pj16dd9.html">To the Max&lpar;矩阵压缩&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jkz0v8.html">Oracle 四种列转行的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j26pv8.html">开涛spring3&lpar;6&period;6&rpar; - AOP 之 6&period;6 通知参数</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv17e7yq.html">python爬虫&colon;使用Selenium模拟浏览器行为</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zo0vdnq.html">常见jquery面试题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyyy5zjq.html">wordpress使用阿里云邮件推送服务实现发送邮件</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7o7d0j8.html">gitlab&plus;jenkins</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qv1ok6xq.html">【前端】Vue2全家桶案例《看漫画》之五、引入axios</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxkr64d8.html">用dd实现linux硬盘备份</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1knwd59.html">R语言︱情感分析&mdash;基于监督算法R语言实现（二）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zo2lvxq.html">图像处理------Mean Shift滤波&lpar;边缘保留的低通滤波&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pdyvvd9.html">zTree实现地市县三级级联Service接口测试</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ey721x9.html">VxWorks启动过程详解（上）</a>
			</li>
						<li><a href="https://www.batexi.com/a/93ylkjg8.html">java&period;lang&period;NumberFormatException</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1kn2049.html">Http请求封装基类HttpHelper&period;cs</a>
			</li>
						<li><a href="https://www.batexi.com/a/93ylre08.html">Xshell配色为ubuntu风格</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7zwyze9.html">使用Spring-boot小结</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
